# coding: utf-8

"""
    CLOUD API

    IONOS Enterprise-grade Infrastructure as a Service (IaaS) solutions can be managed through the Cloud API, in addition or as an alternative to the \"Data Center Designer\" (DCD) browser-based tool.    Both methods employ consistent concepts and features, deliver similar power and flexibility, and can be used to perform a multitude of management tasks, including adding servers, volumes, configuring networks, and so on.  # noqa: E501

    The version of the OpenAPI document: 6.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud.configuration import Configuration


class ServerEntities(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {

        'cdroms': 'Cdroms',

        'nics': 'Nics',

        'volumes': 'AttachedVolumes',
    }

    attribute_map = {

        'cdroms': 'cdroms',

        'nics': 'nics',

        'volumes': 'volumes',
    }

    def __init__(self, cdroms=None, nics=None, volumes=None, local_vars_configuration=None):  # noqa: E501
        """ServerEntities - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._cdroms = None
        self._nics = None
        self._volumes = None
        self.discriminator = None

        if cdroms is not None:
            self.cdroms = cdroms
        if nics is not None:
            self.nics = nics
        if volumes is not None:
            self.volumes = volumes


    @property
    def cdroms(self):
        """Gets the cdroms of this ServerEntities.  # noqa: E501


        :return: The cdroms of this ServerEntities.  # noqa: E501
        :rtype: Cdroms
        """
        return self._cdroms

    @cdroms.setter
    def cdroms(self, cdroms):
        """Sets the cdroms of this ServerEntities.


        :param cdroms: The cdroms of this ServerEntities.  # noqa: E501
        :type cdroms: Cdroms
        """

        self._cdroms = cdroms

    @property
    def nics(self):
        """Gets the nics of this ServerEntities.  # noqa: E501


        :return: The nics of this ServerEntities.  # noqa: E501
        :rtype: Nics
        """
        return self._nics

    @nics.setter
    def nics(self, nics):
        """Sets the nics of this ServerEntities.


        :param nics: The nics of this ServerEntities.  # noqa: E501
        :type nics: Nics
        """

        self._nics = nics

    @property
    def volumes(self):
        """Gets the volumes of this ServerEntities.  # noqa: E501


        :return: The volumes of this ServerEntities.  # noqa: E501
        :rtype: AttachedVolumes
        """
        return self._volumes

    @volumes.setter
    def volumes(self, volumes):
        """Sets the volumes of this ServerEntities.


        :param volumes: The volumes of this ServerEntities.  # noqa: E501
        :type volumes: AttachedVolumes
        """

        self._volumes = volumes
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServerEntities):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ServerEntities):
            return True

        return self.to_dict() != other.to_dict()
